diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.42/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.41/src/wifi/test/spectrum-wifi-phy-test.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/test/spectrum-wifi-phy-test.cc	2024-05-29 15:29:47.216073800 -0700
@@ -1397,7 +1602,208 @@
         }
     }
 
-    Simulator::Stop(Seconds(30));
+    if (m_trackSignalsInactiveInterfaces)
+    {
+        /* Reproduce an EMLSR scenario where a PHY is on an initial band and receives a packet.
+         * Then, the PHY switches to another band where it starts receiving another packet.
+         * During reception of the PHY header, the PHY switches back to the initial band and starts
+         * receiving yet another packet. In this case, first and last packets should be successfully
+         * received (no interference), the second packet reception has been interrupted (before the
+         * payload reception does start, hence it does not reach the RX state). */
+        {
+            // first TX on initial band
+            auto txPpduPhy = m_txPhys.at(0);
+            delay += Seconds(1);
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
+                                this,
+                                txPpduPhy,
+                                20,
+                                500);
+
+            // switch channel to other band
+            delay += Seconds(1);
+            txPpduPhy = m_txPhys.at(1);
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
+                                this,
+                                m_rxPhys.at(0),
+                                txPpduPhy->GetPhyBand(),
+                                txPpduPhy->GetChannelNumber(),
+                                txPpduPhy->GetChannelWidth(),
+                                0);
+
+            // TX on other band
+            delay += Seconds(1);
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
+                                this,
+                                txPpduPhy,
+                                0,
+                                1000);
+
+            // switch back to initial band during PHY header reception
+            txPpduPhy = m_txPhys.at(0);
+            delay += MicroSeconds(20); // right after legacy PHY header reception
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
+                                this,
+                                m_rxPhys.at(0),
+                                txPpduPhy->GetPhyBand(),
+                                txPpduPhy->GetChannelNumber(),
+                                txPpduPhy->GetChannelWidth(),
+                                0);
+
+            // TX once more on the initial band
+            delay += Seconds(1);
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
+                                this,
+                                txPpduPhy,
+                                0,
+                                1500);
+
+            // check results
+            Simulator::Schedule(
+                delay + checkResultsDelay,
+                &SpectrumWifiPhyMultipleInterfacesTest::CheckResults,
+                this,
+                0,
+                3,    // 3 RX events
+                2,    // 2 packets should have been successfully received, 1 packet should
+                      // have been interrupted (switch during PHY header reception)
+                2000, // 500 bytes (firstpacket) and 1500 bytes (third packet)
+                txPpduPhy->GetCurrentFrequencyRange(),
+                expectedConnectedPhysPerChannel);
+
+            // reset
+            Simulator::Schedule(delay + flushResultsDelay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::Reset,
+                                this);
+        }
+
+        /* Reproduce an EMLSR scenario where a PHY is on an initial band and receives a packet
+         * but switches to another band during preamble detection period. Then, it starts receiving
+         * two packets which interfere with each other. Afterwards, the PHY goes back to its initial
+         * band and starts receiving yet another packet. In this case, only the last packet should
+         * be successfully received (no interference). */
+        {
+            // switch channel of PHY index 0 to 5 GHz low band (operating channel of TX PHY index 1)
+            auto txPpduPhy = m_txPhys.at(1);
+            delay += Seconds(1);
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
+                                this,
+                                m_rxPhys.at(0),
+                                txPpduPhy->GetPhyBand(),
+                                txPpduPhy->GetChannelNumber(),
+                                txPpduPhy->GetChannelWidth(),
+                                0);
+
+            // start transmission on 5 GHz low band
+            delay += Seconds(1);
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
+                                this,
+                                txPpduPhy,
+                                20,
+                                500);
+
+            // switch channel back to previous channel before preamble detection is finished:
+            // this is needed to verify interference helper rxing state is properly reset
+            // since ongoing reception is aborted when switching operating channel
+            Simulator::Schedule(delay + MicroSeconds(2),
+                                &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
+                                this,
+                                m_rxPhys.at(0),
+                                m_txPhys.at(0)->GetPhyBand(),
+                                m_txPhys.at(0)->GetChannelNumber(),
+                                m_txPhys.at(0)->GetChannelWidth(),
+                                0);
+
+            delay += Seconds(1);
+            // we need 2 TX PHYs on the 5 GHz low band to have simultaneous transmissions
+            // switch operating channel of TX PHY index 2 to the 5 GHz low band
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
+                                this,
+                                m_txPhys.at(2),
+                                txPpduPhy->GetPhyBand(),
+                                txPpduPhy->GetChannelNumber(),
+                                txPpduPhy->GetChannelWidth(),
+                                std::nullopt);
+
+            // first transmission on 5 GHz low band with high power
+            delay += Seconds(1);
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
+                                this,
+                                txPpduPhy,
+                                20,
+                                1000);
+
+            // second transmission on 5 GHz low band  with high power a bit later:
+            // first powers get updated updated in the corresponding bands
+            txPpduPhy = m_txPhys.at(2);
+            Simulator::Schedule(delay + NanoSeconds(10),
+                                &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
+                                this,
+                                txPpduPhy,
+                                20,
+                                1000);
+
+            // restore channel for TX PHY index 2
+            delay += Seconds(1);
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
+                                this,
+                                m_txPhys.at(2),
+                                m_rxPhys.at(2)->GetPhyBand(),
+                                m_rxPhys.at(2)->GetChannelNumber(),
+                                m_rxPhys.at(2)->GetChannelWidth(),
+                                std::nullopt);
+
+            // switch channel of PHY index 0 to 5 GHz low band again
+            delay += Seconds(1);
+            txPpduPhy = m_txPhys.at(1);
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
+                                this,
+                                m_rxPhys.at(0),
+                                txPpduPhy->GetPhyBand(),
+                                txPpduPhy->GetChannelNumber(),
+                                txPpduPhy->GetChannelWidth(),
+                                0);
+
+            // transmit PPDU on 5 GHz low band (no interference)
+            delay += Seconds(1);
+            Simulator::Schedule(delay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
+                                this,
+                                txPpduPhy,
+                                0,
+                                1500);
+
+            // check results
+            Simulator::Schedule(delay + checkResultsDelay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::CheckResults,
+                                this,
+                                0,
+                                1, // 1 RX event
+                                1, // last transmitted packet should have been successfully received
+                                1500, // 1500 bytes (payload of last transmitted packet)
+                                txPpduPhy->GetCurrentFrequencyRange(),
+                                expectedConnectedPhysPerChannel);
+
+            // reset
+            Simulator::Schedule(delay + flushResultsDelay,
+                                &SpectrumWifiPhyMultipleInterfacesTest::Reset,
+                                this);
+        }
+    }
+
+    delay += Seconds(1);
+    Simulator::Stop(delay);
     Simulator::Run();
 }
 
@@ -1603,14 +2009,24 @@
 };
 
 SpectrumWifiPhyTestSuite::SpectrumWifiPhyTestSuite()
-    : TestSuite("wifi-spectrum-wifi-phy", UNIT)
+    : TestSuite("wifi-spectrum-wifi-phy", Type::UNIT)
 {
-    AddTestCase(new SpectrumWifiPhyBasicTest, TestCase::QUICK);
-    AddTestCase(new SpectrumWifiPhyListenerTest, TestCase::QUICK);
-    AddTestCase(new SpectrumWifiPhyFilterTest, TestCase::QUICK);
-    AddTestCase(new SpectrumWifiPhyMultipleInterfacesTest(false), TestCase::QUICK);
-    AddTestCase(new SpectrumWifiPhyMultipleInterfacesTest(true), TestCase::QUICK);
-    AddTestCase(new SpectrumWifiPhyInterfacesHelperTest, TestCase::QUICK);
+    AddTestCase(new SpectrumWifiPhyBasicTest, TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumWifiPhyListenerTest, TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumWifiPhyFilterTest, TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumWifiPhyMultipleInterfacesTest(
+                    false,
+                    SpectrumWifiPhyMultipleInterfacesTest::ChannelSwitchScenario::BEFORE_TX),
+                TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumWifiPhyMultipleInterfacesTest(
+                    true,
+                    SpectrumWifiPhyMultipleInterfacesTest::ChannelSwitchScenario::BEFORE_TX),
+                TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumWifiPhyMultipleInterfacesTest(
+                    true,
+                    SpectrumWifiPhyMultipleInterfacesTest::ChannelSwitchScenario::BETWEEN_TX_RX),
+                TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumWifiPhyInterfacesHelperTest, TestCase::Duration::QUICK);
 }
 
 static SpectrumWifiPhyTestSuite spectrumWifiPhyTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/tx-duration-test.cc ns-3.42/src/wifi/test/tx-duration-test.cc
--- ns-3.41/src/wifi/test/tx-duration-test.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/test/tx-duration-test.cc	2024-05-29 15:29:47.216073800 -0700
@@ -1801,11 +1801,11 @@
 };
 
 TxDurationTestSuite::TxDurationTestSuite()
-    : TestSuite("wifi-devices-tx-duration", UNIT)
+    : TestSuite("wifi-devices-tx-duration", Type::UNIT)
 {
-    AddTestCase(new TxDurationTest, TestCase::QUICK);
+    AddTestCase(new TxDurationTest, TestCase::Duration::QUICK);
 
-    AddTestCase(new PhyHeaderSectionsTest, TestCase::QUICK);
+    AddTestCase(new PhyHeaderSectionsTest, TestCase::Duration::QUICK);
 
     // 20 MHz band, HeSigBDurationTest::OFDMA, even number of users per HE-SIG-B content channel
     AddTestCase(new HeSigBDurationTest(
@@ -1816,7 +1816,7 @@
                     {96},
                     std::make_pair(2, 0), // both users in HE-SIG-B content channel 1
                     MicroSeconds(4)),     // one OFDM symbol;
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 40 MHz band, HeSigBDurationTest::OFDMA, even number of users per HE-SIG-B content channel
     AddTestCase(
@@ -1833,7 +1833,7 @@
                                std::make_pair(2, 4), // two users in HE-SIG-B content channel 1 and
                                                      // four users in HE-SIG-B content channel 2
                                MicroSeconds(4)),     // one OFDM symbol;
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 40 MHz band, HeSigBDurationTest::OFDMA, odd number of users per HE-SIG-B content channel
     AddTestCase(
@@ -1851,7 +1851,7 @@
                                std::make_pair(2, 5), // two users in HE-SIG-B content channel 1 and
                                                      // five users in HE-SIG-B content channel 2
                                MicroSeconds(8)),     // two OFDM symbols
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 80 MHz band, OFDMA
     AddTestCase(
@@ -1871,7 +1871,7 @@
                                std::make_pair(3, 6), // three users in HE-SIG-B content channel 1
                                                      // and six users in HE-SIG-B content channel 2
                                MicroSeconds(16)),    // four OFDM symbols
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 160 MHz band, OFDMA
     AddTestCase(
@@ -1892,7 +1892,7 @@
                                std::make_pair(4, 7), // four users in HE-SIG-B content channel 1 and
                                                      // seven users in HE-SIG-B content channel 2
                                MicroSeconds(20)),    // five OFDM symbols
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 20 MHz band, HeSigBDurationTest::OFDMA, one unallocated RU at the middle
     AddTestCase(
@@ -1910,7 +1910,7 @@
                                {0},
                                std::make_pair(9, 0), // 9 users in HE-SIG-B content channel 1
                                MicroSeconds(8)),     // two OFDM symbols
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 40 MHz band, HeSigBDurationTest::OFDMA, unallocated RUs at the begin and at the end of the
     // first 20 MHz subband and in the middle of the second 20 MHz subband
@@ -1925,7 +1925,7 @@
                                {112, 112},
                                std::make_pair(4, 4), // 4 users in both HE-SIG-B content channels
                                MicroSeconds(4)),     // two OFDM symbols
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 40 MHz band, HeSigBDurationTest::OFDMA, one unallocated RUs in the first 20 MHz subband and
     // two unallocated RUs in second 20 MHz subband
@@ -1941,7 +1941,7 @@
                                {112, 112},
                                std::make_pair(4, 4), // 4 users in both HE-SIG-B content channels
                                MicroSeconds(4)),     // two OFDM symbols
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 20 MHz band, MU-MIMO, 2 users
     AddTestCase(new HeSigBDurationTest(
@@ -1952,7 +1952,7 @@
                     {192},
                     std::make_pair(2, 0), // both users in HE-SIG-B content channel 1
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 20 MHz band, MU-MIMO, 3 users
     AddTestCase(
@@ -1965,7 +1965,7 @@
                                {192},
                                std::make_pair(3, 0), // all users in HE-SIG-B content channel 1
                                MicroSeconds(4)),     // one OFDM symbol
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 20 MHz band, MU-MIMO, 4 users
     AddTestCase(
@@ -1979,7 +1979,7 @@
                                {192},
                                std::make_pair(4, 0), // all users in HE-SIG-B content channel 1
                                MicroSeconds(4)),     // one OFDM symbol
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 20 MHz band, MU-MIMO, 6 users
     AddTestCase(
@@ -1995,7 +1995,7 @@
                                {192},
                                std::make_pair(6, 0), // all users in HE-SIG-B content channel 1
                                MicroSeconds(4)),     // one OFDM symbol
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 20 MHz band, MU-MIMO, 8 users
     AddTestCase(
@@ -2013,7 +2013,7 @@
                                {192},
                                std::make_pair(8, 0), // all users in HE-SIG-B content channel 1
                                MicroSeconds(8)),     // two OFDM symbols
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 40 MHz band, MU-MIMO, 2 users
     AddTestCase(new HeSigBDurationTest(
@@ -2024,7 +2024,7 @@
                     {200, 200},
                     std::make_pair(1, 1), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 40 MHz band, MU-MIMO, 3 users
     AddTestCase(
@@ -2038,7 +2038,7 @@
             {200, 200},
             std::make_pair(2, 1), // 2 users in content channel 1 and 1 user in content channel 2
             MicroSeconds(4)),     // one OFDM symbol
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 40 MHz band, MU-MIMO, 4 users
     AddTestCase(new HeSigBDurationTest(
@@ -2052,7 +2052,7 @@
                     {200, 200},
                     std::make_pair(2, 2), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 40 MHz band, MU-MIMO, 6 users
     AddTestCase(new HeSigBDurationTest(
@@ -2068,7 +2068,7 @@
                     {200, 200},
                     std::make_pair(3, 3), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 40 MHz band, MU-MIMO, 8 users
     AddTestCase(new HeSigBDurationTest(
@@ -2086,7 +2086,7 @@
                     {200, 200},
                     std::make_pair(4, 4), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 80 MHz band, MU-MIMO, 2 users
     AddTestCase(new HeSigBDurationTest(
@@ -2097,7 +2097,7 @@
                     {208, 208, 208, 208},
                     std::make_pair(1, 1), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 80 MHz band, MU-MIMO, 3 users
     AddTestCase(
@@ -2111,7 +2111,7 @@
             {208, 208, 208, 208},
             std::make_pair(2, 1), // 2 users in content channel 1 and 1 user in content channel 2
             MicroSeconds(4)),     // one OFDM symbol
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 80 MHz band, MU-MIMO, 4 users
     AddTestCase(new HeSigBDurationTest(
@@ -2125,7 +2125,7 @@
                     {208, 208, 208, 208},
                     std::make_pair(2, 2), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 80 MHz band, MU-MIMO, 6 users
     AddTestCase(new HeSigBDurationTest(
@@ -2141,7 +2141,7 @@
                     {208, 208, 208, 208},
                     std::make_pair(3, 3), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 80 MHz band, MU-MIMO, 8 users
     AddTestCase(new HeSigBDurationTest(
@@ -2159,7 +2159,7 @@
                     {208, 208, 208, 208},
                     std::make_pair(4, 4), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 160 MHz band, MU-MIMO, 2 users
     AddTestCase(
@@ -2171,7 +2171,7 @@
             {208, 208, 208, 208, 208, 208, 208, 208},
             std::make_pair(1, 1), // users equally split between the two content channels
             MicroSeconds(4)),     // one OFDM symbol
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 160 MHz band, MU-MIMO, 3 users
     AddTestCase(
@@ -2185,7 +2185,7 @@
             {208, 208, 208, 208, 208, 208, 208, 208},
             std::make_pair(2, 1), // 2 users in content channel 1 and 1 user in content channel 2
             MicroSeconds(4)),     // one OFDM symbol
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     // 160 MHz band, MU-MIMO, 4 users
     AddTestCase(new HeSigBDurationTest(
@@ -2199,7 +2199,7 @@
                     {208, 208, 208, 208, 208, 208, 208, 208},
                     std::make_pair(2, 2), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 160 MHz band, MU-MIMO, 6 users
     AddTestCase(new HeSigBDurationTest(
@@ -2215,7 +2215,7 @@
                     {208, 208, 208, 208, 208, 208, 208, 208},
                     std::make_pair(3, 3), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // 160 MHz band, MU-MIMO, 8 users
     AddTestCase(new HeSigBDurationTest(
@@ -2233,7 +2233,7 @@
                     {208, 208, 208, 208, 208, 208, 208, 208},
                     std::make_pair(4, 4), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 }
 
 static TxDurationTestSuite g_txDurationTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-aggregation-test.cc ns-3.42/src/wifi/test/wifi-aggregation-test.cc
--- ns-3.41/src/wifi/test/wifi-aggregation-test.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/test/wifi-aggregation-test.cc	2024-05-29 15:29:47.216073800 -0700
@@ -214,7 +214,17 @@
     /*
      * Create and configure mac layer.
      */
-    m_mac = CreateObjectWithAttributes<StaWifiMac>("QosSupported", BooleanValue(true));
+    m_mac = CreateObjectWithAttributes<StaWifiMac>(
+        "QosSupported",
+        BooleanValue(true),
+        "BE_Txop",
+        PointerValue(CreateObjectWithAttributes<QosTxop>("AcIndex", StringValue("AC_BE"))),
+        "BK_Txop",
+        PointerValue(CreateObjectWithAttributes<QosTxop>("AcIndex", StringValue("AC_BK"))),
+        "VI_Txop",
+        PointerValue(CreateObjectWithAttributes<QosTxop>("AcIndex", StringValue("AC_VI"))),
+        "VO_Txop",
+        PointerValue(CreateObjectWithAttributes<QosTxop>("AcIndex", StringValue("AC_VO"))));
     m_mac->SetDevice(m_device);
     m_mac->SetWifiRemoteStationManagers(m_managers);
     for (uint8_t i = 0; i < m_params.nLinks; i++)
@@ -224,19 +234,30 @@
     m_mac->SetAddress(Mac48Address("00:00:00:00:00:01"));
     m_device->SetMac(m_mac);
     m_mac->SetWifiPhys(m_phys);
-    m_mac->ConfigureStandard(m_params.standard);
+    std::vector<Ptr<ChannelAccessManager>> caManagers;
     for (uint8_t i = 0; i < m_params.nLinks; i++)
     {
-        auto fem = m_mac->GetFrameExchangeManager(i);
+        caManagers.emplace_back(CreateObject<ChannelAccessManager>());
+    }
+    m_mac->SetChannelAccessManagers(caManagers);
+    ObjectFactory femFactory;
+    femFactory.SetTypeId(GetFrameExchangeManagerTypeIdName(m_params.standard, true));
+    std::vector<Ptr<FrameExchangeManager>> feManagers;
+    for (uint8_t i = 0; i < m_params.nLinks; i++)
+    {
+        auto fem = femFactory.Create<FrameExchangeManager>();
+        feManagers.emplace_back(fem);
         auto protectionManager = CreateObject<WifiDefaultProtectionManager>();
         protectionManager->SetWifiMac(m_mac);
         fem->SetProtectionManager(protectionManager);
         auto ackManager = CreateObject<WifiDefaultAckManager>();
         ackManager->SetWifiMac(m_mac);
         fem->SetAckManager(ackManager);
-        // here we should assign link addresses in case of MLDs, but we don't actually use link
-        // addresses in this test
+        // here we should assign distinct link addresses in case of MLDs, but we don't actually use
+        // link addresses in this test
+        fem->SetAddress(m_mac->GetAddress());
     }
+    m_mac->SetFrameExchangeManagers(feManagers);
     m_mac->SetState(StaWifiMac::ASSOCIATED);
     if (m_params.nLinks > 1)
     {
@@ -1136,15 +1157,15 @@
 };
 
 WifiAggregationTestSuite::WifiAggregationTestSuite()
-    : TestSuite("wifi-aggregation", UNIT)
+    : TestSuite("wifi-aggregation", Type::UNIT)
 {
-    AddTestCase(new AmpduAggregationTest, TestCase::QUICK);
-    AddTestCase(new TwoLevelAggregationTest, TestCase::QUICK);
-    AddTestCase(new HeAggregationTest(64), TestCase::QUICK);
-    AddTestCase(new HeAggregationTest(256), TestCase::QUICK);
-    AddTestCase(new EhtAggregationTest(512), TestCase::QUICK);
-    AddTestCase(new EhtAggregationTest(1024), TestCase::QUICK);
-    AddTestCase(new PreservePacketsInAmpdus, TestCase::QUICK);
+    AddTestCase(new AmpduAggregationTest, TestCase::Duration::QUICK);
+    AddTestCase(new TwoLevelAggregationTest, TestCase::Duration::QUICK);
+    AddTestCase(new HeAggregationTest(64), TestCase::Duration::QUICK);
+    AddTestCase(new HeAggregationTest(256), TestCase::Duration::QUICK);
+    AddTestCase(new EhtAggregationTest(512), TestCase::Duration::QUICK);
+    AddTestCase(new EhtAggregationTest(1024), TestCase::Duration::QUICK);
+    AddTestCase(new PreservePacketsInAmpdus, TestCase::Duration::QUICK);
 }
 
 static WifiAggregationTestSuite g_wifiAggregationTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-channel-switching-test.cc ns-3.42/src/wifi/test/wifi-channel-switching-test.cc
--- ns-3.41/src/wifi/test/wifi-channel-switching-test.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/test/wifi-channel-switching-test.cc	2024-05-29 15:29:47.216073800 -0700
@@ -315,9 +315,9 @@
 };
 
 WifiChannelSwitchingTestSuite::WifiChannelSwitchingTestSuite()
-    : TestSuite("wifi-channel-switching", UNIT)
+    : TestSuite("wifi-channel-switching", Type::UNIT)
 {
-    AddTestCase(new WifiChannelSwitchingTest, TestCase::QUICK);
+    AddTestCase(new WifiChannelSwitchingTest, TestCase::Duration::QUICK);
 }
 
 static WifiChannelSwitchingTestSuite g_issue211TestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-dynamic-bw-op-test.cc ns-3.42/src/wifi/test/wifi-dynamic-bw-op-test.cc
--- ns-3.41/src/wifi/test/wifi-dynamic-bw-op-test.cc	2024-02-09 14:44:08.609795000 -0800
+++ ns-3.42/src/wifi/test/wifi-dynamic-bw-op-test.cc	2024-05-29 15:29:47.216073800 -0700
@@ -430,7 +430,7 @@
 };
 
 WifiDynamicBwOpTestSuite::WifiDynamicBwOpTestSuite()
-    : TestSuite("wifi-dynamic-bw-op", UNIT)
+    : TestSuite("wifi-dynamic-bw-op", Type::UNIT)
 {
     /**
      *                    primary20
@@ -443,7 +443,7 @@
      *          └────────┘
      */
     AddTestCase(new WifiUseAvailBwTest({"{54, 40, BAND_5GHZ, 1}", "{52, 20, BAND_5GHZ, 0}"}, 20),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     /**
      *           ─── primary 40 ───
      *           primary20
@@ -457,7 +457,7 @@
      *                                      primary20
      */
     AddTestCase(new WifiUseAvailBwTest({"{58, 80, BAND_5GHZ, 0}", "{62, 40, BAND_5GHZ, 1}"}, 40),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     /**
      *                                               ─────────── primary 80 ───────────
      *                                                       primary20
@@ -471,7 +471,7 @@
      *                             primary20
      */
     AddTestCase(new WifiUseAvailBwTest({"{50, 160, BAND_5GHZ, 5}", "{42, 80, BAND_5GHZ, 2}"}, 80),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 }
 
 static WifiDynamicBwOpTestSuite g_wifiDynamicBwOpTestSuite; ///< the test suite
